(+ 3 4) ; 3+4 in Lisp syntax (prefix notation)

(defun f (x) ; define f(x) = x+10
  (+ x 10))

(f 3) ; f(3)

(* (f 0) (f 1)) ; f(0) * f(1)

(thm ; trivial theorem: f(x) = 10+x
 (equal (f x)
        (+ 10 x)))

(thm
 ;; trivially proved by execution: f(0)*f(1) = 110
 (equal (* (f 0) (f 1))
        110))

(defun fact (n) ; factorial
  (if (posp n) ; n is a positive integer
      (* n (fact (- n 1)))
    1))

(thm  ; trivial theorem, proved by execution
 (equal (fact 100)
        93326215443944152681699238856266700490715968264381621468592963895217599993229915608941463976156518286253697920827223758251185210916864000000000000000000000000))

(integer-length (fact 10000)) ; number of bits in answer

(defun fib (n) ; much more expensive than factorial!
  (declare (type (integer 0 *) n))
  (if (posp n)
      (if (equal n 1)
          1
        (+ (fib (- n 1))
           (fib (- n 2))))
    1))

(time$ (fib 30))
(time$ (fib 40)) ; exponential time behavior!

(memoize 'fib)

(time$ (fib 40)) ; virtually instantaneous!
