(defun sum-to-n (n)
  ;; Recursive definition:
  ;; ACL2 proves that n-1 is less than n when
  ;; n is a positive integer.
  (if (posp n) ; n is a positive integer
      (+ n (sum-to-n (- n 1)))
    0))

(thm ; sum-to-n(n) = n(n+1)/2
 (implies (natp n)
          (equal (sum-to-n n)
                 (/ (* n (+ n 1))
                    2))))

(include-book "arithmetic/top" ; a "community book"
              :dir :system)

(thm ; sum-to-n(n) = n(n+1)/2 (succeeds this time)
 (implies (natp n)
          (equal (sum-to-n n)
                 (/ (* n (+ n 1))
                    2))))

:pso ; "print saved output"

(thm 
 ;; sum-to-n(2k) = 2k(2k+1)/2 = k(2k+1)
 ;; Fails (induction not found; thm was not stored)
 (implies (natp k)
          (equal (sum-to-n (* 2 k))
                 (* k (+ (* 2 k) 1)))))

(defthm sum-to-n-rewrite
  ;; Prove and store a rewrite rule
  ;; to replace sum-to-n(n) by n(n+1)/2.
  (implies (natp n)
           (equal (sum-to-n n)
                  (/ (* n (+ n 1))
                     2))))

:pbt 0 ; commands in the current "ACL2 logical world".

(thm ; proof succeeds immediately
 (implies (natp k)
          (equal (sum-to-n (* 2 k))
                 (* k (+ (* 2 k) 1)))))

:pso
