; Certify this book with:
; (certify-book "demo-gl")

; The def-gl-thm example is adapted directly from
; the Community Books, specifically:

; projects/x86isa/machine/x86-top-level-memory.lisp

(in-package "ACL2")

; The following include-book is what
; takes almost all of the time.
(local (include-book "centaur/gl/gl" :dir :system))

(local
 (defun gl-int (start by count)
   (if (zp count)
       nil
     (cons start
           (gl-int (+ by start) by (1- count))))))

(local
 (def-gl-thm rb-and-rvm64-helper
   :hyp
   (and (unsigned-byte-p 8 a)
        (unsigned-byte-p 8 b)
        (unsigned-byte-p 8 c)
        (unsigned-byte-p 8 d)
        (unsigned-byte-p 32 x))
   :concl
   (equal (logior a
                  (ash (logior b (ash (logior c (ash d 8)) 8)) 8)
                  (ash x 32))
          (logior a
                  (ash (logior b (ash (logior c (ash (logior d (ash x 8)) 8))
                                      8))
                       8)))
   :g-bindings
   `((a (:g-number ,(gl-int 0 5 33)))
     (b (:g-number ,(gl-int 1 5 33)))
     (c (:g-number ,(gl-int 2 5 33)))
     (d (:g-number ,(gl-int 3 5 33)))
     (x (:g-number ,(gl-int 4 5 33))))))

 ;; Redundant:
(defthm rb-and-rvm64-helper
  (implies (and (unsigned-byte-p 8 a)
                (unsigned-byte-p 8 b)
                (unsigned-byte-p 8 c)
                (unsigned-byte-p 8 d)
                (unsigned-byte-p 32 x))
           (equal
            (logior a
                    (ash (logior b (ash (logior c (ash d 8)) 8))
                         8)
                    (ash x 32))
            (logior
             a
             (ash (logior b
                          (ash (logior c (ash (logior d (ash x 8)) 8))
                               8))
                  8)))))
